import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.PortableServer.*;

import SalleEnchere.*;
import NommageFacile.*;

public class ClientSDV extends Thread {

    private String[] arguments;
    
    /**
     * Constructeurs.
     */
    public ClientSDV() {
    }

    public ClientSDV(String[] args) {
	arguments = args;
    }

    /**
     * mthode run
     */
    public void run(){
        try{
           java.util.Properties props = System.getProperties();
	   props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	   props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
	   System.setProperties(props);
           //cration de l'objet ORB
	   org.omg.CORBA.ORB orb = null;
	   orb = org.omg.CORBA.ORB.init(arguments, props);
	   runSuite(orb);
	}catch(Exception ex) {
	      ex.printStackTrace();
	}
    }    
    
    /**
     * run de l'ORB, lancement de l'interface graphique et du service de notification
     */
    private static void runSuite(org.omg.CORBA.ORB orb) {

      //Lancement de l'orb
      //System.out.println("Lancement de l'orb");
      //orb.run();	
      
      //Lancement de l'interface graphique
      System.out.println("Rcuprer la rfrence de la salle de vente");
      SalleVente salleDesVentes = getSalleVente(orb);
      System.out.println("Lancement de l'interface graphique");
      FenetreClient fenetreClient = new FenetreClient(salleDesVentes);

      //mettre ce process client en attente de la connexion du client avec la salle de vente.
      //Cela est ncessaire pour crer notifyListener  partir de l'identificateur de service d'vnement (EventServiceId)
      //qu'on obtient lors de la connexion avec la salle de vente.
      System.out.println("Mise en attente");
      fenetreClient.attendreConnexionAvecSDV();

      //Lancement du service de notification
      System.out.println("Lancement du service de notification");
      try {
	    org.omg.CORBA.Object obj = orb.resolve_initial_references("RootPOA");
	    POA rootPOA = POAHelper.narrow(obj);
	    POAManager manager = rootPOA.the_POAManager();  
	    EventListenerSDV notifyListener = new EventListenerSDV(orb, rootPOA, fenetreClient);
	    notifyListener.run();
	    manager.activate();
	    orb.run();
      }catch (Exception e) {
	    e.printStackTrace();
	    System.exit(1);
      }

    }

    /**
     * Permet d'obtenir une salle des ventes
     * Cette mthode utilise le service de nommage
     */
    private static SalleVente getSalleVente(org.omg.CORBA.ORB orb) {
	
	org.omg.CORBA.Object obj = null;
	String nomObjet = new String("quad:10000:/sallesDeVentes/salle1");
	
  	obj = EasyNaming.resoudreReferenceObjet(orb, nomObjet);
	
	// Convertir en une SalleVente::salleDesVentes
	SalleVente salleDesVentes = SalleVenteHelper.narrow(obj);
	return salleDesVentes;
    }

}


