import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.*;
import org.omg.CosNotifyComm.*;
import org.omg.CosNotification.*;

import SalleEnchere.*;
import VenteAuxEncheres.*;
import SalleEnchere.SalleVentePackage.*;

import easyNotify.*;   // paquetage de Philippe Lamarre

/**
 * Ce listener prvient qu'un vnement s'est produit dans une salle
 * des ventes.
 */
public class EventListenerSDV implements EasyStructuredEventDealer {

    protected ORB orb;

    protected POA poa;

    protected EasyNotifyStructuredPushConsumer easyConsumer;

    /** l'interface graphique qui doit tre mise  jour */
    protected FenetreClient fenetreClient;

    /**
      * Constructeur
      */
    public EventListenerSDV(ORB orb, POA poa, FenetreClient fenetreClient){

	this.orb = orb;
	this.poa = poa;
      this.fenetreClient = fenetreClient;

      //rcuprer dans fenetreClient l'id du service d'vnement obtenu
      //lors de la connexion avec la salle de vente,
      //contient un numro de canal, un numro de port, un nom de machine
      EventServiceIdHolder idServiceEvenement = fenetreClient.getEventServiceId();

	try {
	    easyConsumer = new EasyNotifyStructuredPushConsumer(orb,
                                                                poa,
						                idServiceEvenement.value.nomMachine,
						                String.valueOf(idServiceEvenement.value.numPort),
                                                                idServiceEvenement.value.numCanal,
						                this);
	}catch (Exception ex){
	    ex.printStackTrace();
	}
    }
    
    public void run() {
	try {
	    easyConsumer.connect();
	}
	catch (Exception e) {
	    e.printStackTrace();
	}
    }
    
    /**
     * traitement des vnements recus
     */
    public void treatEvent(StructuredEvent event) {
	try {
	    SdvEvent myEvent = new SdvEvent(event);
	    fenetreClient.treatEvent(myEvent);
	}
	catch (BadEvent e) {
	    e.printStackTrace();
	    System.err.println(new EasyStructuredEvent(event).toString());
	}
    }
    
}
