import javax.swing.*;
import javax.swing.table.TableModel;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

import org.omg.CORBA.*;

import SalleEnchere.*;
import VenteAuxEncheres.*;
import SalleEnchere.SalleVentePackage.*;


/*
 * Panel pour un tableur
 *
 */
class PanelTableur extends JPanel implements TableModelListener{
	
	TableModel tableur;
	
	public PanelTableur(java.lang.Object[][] donnees, String[] nomsColonnes){
		
	  JTable table = new JTable(donnees,nomsColonnes);
	  table.setPreferredScrollableViewportSize(new Dimension(400,100));
	  setLayout(new BorderLayout());
	  add(new JScrollPane(table));
	  tableur = table.getModel();
	  tableur.addTableModelListener(this);
	  
	}
	
	public void tableChanged(TableModelEvent e){
		
	}
	 
} //fin de la classe PanelTableur


/*
 * classe FenetreCatalogue
 *
 */
class FenetreCatalogue extends JFrame {

 /* constructeur de la fentre */
 public FenetreCatalogue(Catalogue catalogue) {

  super("le catalogue");

  //on rcupre les donnes
  java.lang.Object [][] donnees;
  donnees = new java.lang.Object [catalogue.produits.length][6];
  for (int i = 0; i < catalogue.produits.length; i++){
     donnees [i][0] = String.valueOf((catalogue.produits)[i].id);     //identifiant 
     donnees [i][1] = (catalogue.produits)[i].nom;                   //nom
     donnees [i][2] = (catalogue.produits)[i].description;           //description
     donnees [i][3] = String.valueOf((catalogue.produits)[i].prixDepart); //prix de dpart
     donnees [i][4] = String.valueOf((catalogue.produits)[i].vendu);      //indique si le produit est vendu
     donnees [i][5] = String.valueOf((catalogue.produits)[i].prixVente);  //indique le prix de vente s'il est vendu
  }
  
  //cration d'un tableur  partir des donnes
  String[] nomsColonnes = {"Identifiant","Nom","Description","Prix Dpart","Est Vendu","Prix de vente"};
  PanelTableur p = new PanelTableur(donnees,nomsColonnes);
  
  //label au dessus du tableur
  final JLabel label = new JLabel("SALLE:" + catalogue.salleDeVente + "TEMPS RESTANT:" + String.valueOf(catalogue.tempsRestant));

  JPanel pTemp = new JPanel();
  pTemp.setLayout(new BorderLayout());
  pTemp.setBackground(Color.lightGray);
  pTemp.add(label,BorderLayout.NORTH);
  pTemp.add(p,BorderLayout.CENTER);
  setContentPane(pTemp);
  
  //rendre la fentre visible
  pack();
  setVisible(true);
  
 }
 
} //fin de la classe FenetreCatalogue


/*
 * classe FenetreClient
 *
 */
class FenetreClient extends JFrame{

 //zones d'infos  saisir pour l'enregistrement
 JTextField texteNom;
 JTextField textePrenom;

 //fenetre pour la vente aux encheres
 FenetreClientSuite fenetreVente;

 //salle des ventes 
 SalleVente salleEnchere;

 /* constructeur de la fentre */
 public FenetreClient(SalleVente laSalleEnchere) {

      salleEnchere = laSalleEnchere;
      fenetreVente = new FenetreClientSuite(salleEnchere);

      //bouton de validation
      JButton boutonValidation = new JButton("Valider");
  
      //action de clique sur ce bouton
      boutonValidation.addActionListener(new ActionListener(){
           public void actionPerformed(ActionEvent e){
               if (!texteNom.getText().equals("") && !textePrenom.getText().equals("")){
                 setVisible(false);
                 fenetreVente.setNomPrenomPersonne(texteNom.getText(),textePrenom.getText());
                 fenetreVente.setVisible(true);
               }
           }
      });
	
      //zones d'infos  saisir
	texteNom = new JTextField(15);
	textePrenom = new JTextField(15);
	
	//panel des infos du client
	JPanel panel = new JPanel();
	panel.setLayout(new GridLayout(2,2,10,10));
	panel.setBackground(Color.lightGray);
	panel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
	panel.add(new JLabel(" Nom      "));
	panel.add(texteNom);
      panel.add(new JLabel(" Prnom   "));
	panel.add(textePrenom);

      //panel principal
      JPanel mainPanel = new JPanel();
      mainPanel.setLayout(new BorderLayout());
      mainPanel.setBackground(Color.lightGray);
      mainPanel.add(panel,BorderLayout.CENTER);
      mainPanel.add(boutonValidation,BorderLayout.SOUTH);
      setContentPane(mainPanel);

	//rendre la fentre visible
	pack();
      setVisible(true);
  
    } //fin du constructeur

    //traite les vnements recus de la salle de vente
    public void treatEvent(SdvEvent e){
      if (fenetreVente!=null) fenetreVente.treatEvent(e);
    }

    //permet  un processus d'tre mis en attente jusqu' ce que la connexion soit tablie
    public void attendreConnexionAvecSDV(){
      if (fenetreVente!=null)
         fenetreVente.attendreConnexionAvecSDV();
    }

    //permet de rcuprer l'identificateur du service d'vnement donn par la salle de vente lors de la connexion
    public EventServiceIdHolder getEventServiceId(){
      if (fenetreVente!=null)
         return fenetreVente.getEventServiceId();
         //contient un numro de canal, un numro de port, un nom de machine
      else
	 return null;
    }

} //fin de la classe FenetreClient


/*
 * classe FenetreClientSuite
 *
 */
class FenetreClientSuite extends JFrame {
 
 SalleVente salleEnchere;     //salle des ventes
 boolean connexionEnCours;    //indique s'il y a une connexion en cours avec la salle des ventes
 EventServiceIdHolder idServiceEvenement; //identificateur du service d'vnement donn par la salle de vente lors de la connexion 

 //informations sur le client
 String nomClient = "";        //nom du client
 String prenomClient = "";     //prenom du client
 int idClient;                  //identifiant du client

 int idProduitCourant;          //identifiant du produit en cours de vente

 //Moniteur de concurrence
 java.lang.Object moniteur = new java.lang.Object();
 
 /* lments graphiques qui peuvent tre modifis */ 
 
  JTextField texteProduitCourant; //indique le produit courant de la vente en cours
  JTextField textePrixCourant;    //indique le prix actuel du produit courant
  JTextField texteIdAcquereur;    //indique l'identifiant de l'acqureur actuel
  JTextField texteStatut;         //indique le statut de la vente : continue, n fois, adjug.
  JTextField texteIdVous;         //permet d'indiquer  l'utilisateur son identifiant 
  JTextField prixVoulu;           //zone texte permettant au client de saisir le prix voulu pour encherir
  JTextField texteInfos;          //zone d'informations diverses pour l'utilisateur
  JButton boutonPourEnregistrer;  //bouton pour s'enregistrer
  JButton boutonPourEncherir;     //bouton pour enchrir
	
 /* constructeur de la fentre */

 public FenetreClientSuite(SalleVente laSalleEnchere){
	
	/* gestion de la fentre */
	
	super("Vente aux enchres");
      
      salleEnchere=laSalleEnchere;
 
      connexionEnCours = false;	

	//action de fermeture de la fenetre
	addWindowListener(new WindowAdapter(){
		public void windowClosed(WindowEvent e){
			if (connexionEnCours) salleEnchere.sortie(idClient);
			System.exit(0);
		}
	});
	
	/* sous-panel pour l'entte de la fentre */

	//bouton de connexion a la salle de vente slectionne
      JButton boutonConnexion = new JButton("Connexion");
	
      //action de clique sur le bouton de connexion
	boutonConnexion.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent e){
              //on sort s'il y a dj une connexion en cours ou si les infos du client sont mal renseignes
	      if (connexionEnCours || nomClient.equals("") || prenomClient.equals("")) return;

              try{

                //client entre dans la salle
                //rcupre son id de client, les paramtres de l'eventService, et l'enchere en cours
                IntHolder id = new IntHolder();
                System.out.println("Essai de connexion");
                idServiceEvenement = new EventServiceIdHolder(new EventServiceId());
                Enchere enchere = salleEnchere.entree(new Personne(nomClient,prenomClient),id,idServiceEvenement);
                idClient = id.value;
                connexionEnCours = true;
                System.out.println("Connexion tablie");
                texteInfos.setText("Connexion tablie");

                //on libre les process clients mis en attente de la connexion
                //moniteur.notifyAll();

                //mise  jour de l'interface avec les lments de l'enchre en cours
                idProduitCourant = enchere.idProduitCourant;
                texteProduitCourant.setText(String.valueOf(idProduitCourant));
                textePrixCourant.setText(String.valueOf(enchere.prixCourant));
                texteIdAcquereur.setText(String.valueOf(enchere.idPersonne));
	          prixVoulu.setText(String.valueOf(enchere.prixCourant + 1));
                Statut statut = enchere.leStatut;
                switch (statut.value()){
		     case Statut._enBaisse : texteStatut.setBackground(Color.red);
                                             texteStatut.setText("Personne n'a enchri donc le prix baisse"); break;
		     case Statut._encheri : texteStatut.setBackground(Color.green);
                                            texteStatut.setText("On a enchri sur l'article"); break;     
		     case Statut._uneFois : texteStatut.setBackground(Color.yellow);
                                            texteStatut.setText("Dcompte une fois"); break; 
		     case Statut._deuxFois : texteStatut.setBackground(Color.yellow);
                                             texteStatut.setText("Dcompte deux fois"); break; 
		     case Statut._troisFois : texteStatut.setBackground(Color.yellow);
                                              texteStatut.setText("Dcompte trois fois"); break; 
		     case Statut._adjuge : texteStatut.setBackground(Color.white);
                                           texteStatut.setText("Adjug"); break; 
		}
               
                //le client est configur pour pouvoir enchrir
	    	    texteIdVous.setText(String.valueOf(idClient));
	          boutonPourEncherir.setEnabled(true);
                prixVoulu.setEditable(true);

              }catch(SalleFermee fermee){
                  texteInfos.setText("La salle est ferme");
              }catch(Exception ex){
                  texteInfos.setText("Problme de connexion");
              }
	    }
      });

	//bouton pour obtenir le catalogue
      JButton boutonCatalogue = new JButton("Catalogue");
  
      //action de clique sur ce bouton
	boutonCatalogue.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent e){
	      try{
                if (salleEnchere != null)
                   new FenetreCatalogue(salleEnchere.getCatalogue());
              }catch(Exception ex){
                  texteInfos.setText("Problme de connexion");
              }
	    }
      });
  
	//panelEntete : Ensemble des composants de l'entte
	JPanel panelEntete = new JPanel();
	panelEntete.setLayout(new BorderLayout());
	panelEntete.setBackground(Color.lightGray);
	panelEntete.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
	//panelEntete.add(listeScrollPane,BorderLayout.CENTER);
	JPanel panelTemp = new JPanel();
	panelTemp.setLayout(new GridLayout(1,2,10,10));
	panelTemp.add(boutonCatalogue);
	panelTemp.add(boutonConnexion);
      panelEntete.add(panelTemp,BorderLayout.CENTER);
  
      /* sous-panel pour le corps de la fentre
	   compos d'un panel d'infos sur la vente en cours
	   et d'un panel d'action permettant au client d'enchrir
       */
	
	//// sous-sous-panel d'infos sur la vente en cours
	
	//zones textes d'infos sur la vente en cours
	texteProduitCourant = new JTextField(15);
	texteProduitCourant.setEditable(false);
	textePrixCourant = new JTextField(15);
	textePrixCourant.setEditable(false);
	texteIdAcquereur = new JTextField(15);
	texteIdAcquereur.setEditable(false);
	texteStatut = new JTextField(15);
	texteStatut.setBackground(Color.white);
	texteStatut.setEditable(false);
	
	//panelInfosVente : Ensemble des composants d'infos sur la vente
	JPanel panelInfosVente = new JPanel();
	panelInfosVente.setLayout(new GridLayout(4,2,10,10));
	//panelInfosVente.setBackground(Color.lightGray);
	panelInfosVente.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
	panelInfosVente.add(new JLabel(" Produit courant                  "));
	panelInfosVente.add(texteProduitCourant);
        panelInfosVente.add(new JLabel(" Prix courant                     "));
        panelInfosVente.add(textePrixCourant);
        panelInfosVente.add(new JLabel(" Identifiant de l'acqureur       "));
        panelInfosVente.add(texteIdAcquereur);
        panelInfosVente.add(new JLabel(" Statut de la vente de ce produit "));
        panelInfosVente.add(texteStatut);
  
	//// sous-sous-panel d'action permettant au client d'enchrir
  
        //bouton pour enchrir
        boutonPourEncherir = new JButton("Enchrir");
        boutonPourEncherir.setEnabled(false);

        //zone texte permettant au client de saisir le prix voulu pour sur-encherir
        prixVoulu = new JTextField(15);
        prixVoulu.setEditable(false);
        
        //zone de texte permettant d'indiquer  l'utilisateur son identifiant pour la vente
        texteIdVous = new JTextField(15);
	      texteIdVous.setEditable(false);
  
        //action de clique sur le bouton pour enchrir
	boutonPourEncherir.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent a){
	      try{
	    	  int nouveauPrix = (Integer.valueOf(prixVoulu.getText())).intValue();
	    	  salleEnchere.encherir(idClient,idProduitCourant,nouveauPrix);
	      }catch(NumberFormatException e1){
	      	texteInfos.setText("Essayer un alcotest svp");
	      }
	      //catch (SalleFermee e2){texteInfos.setText("La salle est ferme");}
	      catch (EnchereBasse e3){texteInfos.setText("Enchre trop basse");}
	      catch (MauvaisProduit e4){texteInfos.setText("Le produit n'est plus en vente");}
              catch(Exception ex){texteInfos.setText("Problme de connexion");}
	    }
        });
  
        //panelActionsVente : Ensemble des composants permettant au client d'enchrir
        JPanel panelActionsVente = new JPanel();
	panelActionsVente.setLayout(new BorderLayout());
	panelActionsVente.setBackground(Color.lightGray);
	panelActionsVente.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
	JPanel pTemp = new JPanel();
	pTemp.setLayout(new GridLayout(2,2,10,10));
	pTemp.setBackground(Color.lightGray);
	pTemp.add(boutonPourEncherir);
	pTemp.add(prixVoulu);
	pTemp.add(new JLabel(" Votre identifiant utilisateur    "));
	pTemp.add(texteIdVous);
        panelActionsVente.add(pTemp,BorderLayout.CENTER);

        //// panelCorps : Ensemble des composants du corps de la fentre
	JPanel panelCorps = new JPanel();
        panelCorps.setLayout(new BorderLayout());
	panelCorps.setBackground(Color.lightGray);
	panelCorps.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
	panelCorps.add(panelInfosVente,BorderLayout.CENTER);
        panelCorps.add(panelActionsVente,BorderLayout.SOUTH);

	/* panel principal */
	
	JPanel mainPanel = new JPanel();
	mainPanel.setLayout(new BorderLayout());
	mainPanel.setBackground(Color.lightGray);
	mainPanel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
        mainPanel.add(panelEntete,BorderLayout.NORTH);
        mainPanel.add(panelCorps,BorderLayout.CENTER);
	
	//ajouter une zone d'informations divers en bas de la fenetre
	texteInfos = new JTextField(20);
	texteInfos.setEditable(false);
	texteInfos.setForeground(Color.red);
	mainPanel.add(texteInfos,BorderLayout.SOUTH);
	
	/* retour  la gestion de la fentre */
	
	//mettre des barres de defilement a la fentre si necessaire	
	JScrollPane scrollPane = new JScrollPane(mainPanel);
	setContentPane(scrollPane);

	pack();
  
 } //fin du constructeur
 
 //met  jour le nom et le prnom du client courant
 public void setNomPrenomPersonne(String leNomClient, String lePrenomClient){
        nomClient = leNomClient;
        prenomClient = lePrenomClient;
 } 

 //traite les vnements de la salle des ventes	
 public void treatEvent(SdvEvent e){
  
  try{
  
  //mise  jour du produit courant
  idProduitCourant = e.getFieldProduit();
  texteProduitCourant.setText(String.valueOf(idProduitCourant));
     
  //mise  jour du prix courant
  textePrixCourant.setText(String.valueOf(e.getFieldPrix()));
	   
  //mise  jour de l'identifiant de l'acqureur
  texteIdAcquereur.setText(String.valueOf(e.getEnchere().idPersonne));
	   
  //donne une valeur par dfaut dans la case du nouveau prix d'enchre voulu
  prixVoulu.setText(String.valueOf(e.getFieldPrix()+10));
  
  //mise  jour du statut de la salle
  Statut statut = e.getFieldStatus();
  switch (statut.value()){
		     case Statut._enBaisse : texteStatut.setBackground(Color.red); 
                                             texteStatut.setText("Personne n'a enchri donc le prix baisse"); break;
		     case Statut._encheri : texteStatut.setBackground(Color.green);
                                            texteStatut.setText("On a enchri sur l'article"); break;     
		     case Statut._uneFois : texteStatut.setBackground(Color.yellow);
                                            texteStatut.setText("Dcompte une fois"); break; 
		     case Statut._deuxFois : texteStatut.setBackground(Color.yellow);
                                             texteStatut.setText("Dcompte deux fois"); break; 
		     case Statut._troisFois : texteStatut.setBackground(Color.yellow);
                                              texteStatut.setText("Dcompte trois fois"); break; 
		     case Statut._adjuge : texteStatut.setBackground(Color.white);
                                           texteStatut.setText("Adjug"); break; 
   }

  }catch (Exception ex){
   texteInfos.setText("Pb pour traiter vnements de la salle");  
  }
 }

 //permet  un processus d'tre mis en attente jusqu' ce que la connexion soit tablie
 public void attendreConnexionAvecSDV(){
     /***** grosse bidouille -> trouver une solution de substitution *****/
     while (!connexionEnCours){
        //try {moniteur.wait();}
        //catch(InterruptedException e){}
     }
 }

 //permet de rcuprer l'identificateur du service d'vnement donn par la salle de vente lors de la connexion
 public EventServiceIdHolder getEventServiceId(){
   return idServiceEvenement;
   //contient un numro de canal, un numro de port, un nom de machine
 }

}//fin de la classe FenetreClientSuite 
